package io.dekorate.s2i.adapter;

import io.dekorate.s2i.config.S2iBuildConfig;
import java.util.stream.Collectors;
import io.dekorate.s2i.config.S2iBuildConfigBuilder;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.project.Project;
import io.dekorate.project.BuildInfo;
import io.dekorate.s2i.annotation.S2iBuild;
import java.lang.Object;
import java.util.List;
import io.dekorate.project.ScmInfo;
import java.lang.Boolean;
import java.util.Arrays;
import java.util.Map;

public class S2iBuildConfigAdapter {


    public static S2iBuildConfig adapt(S2iBuild instance) {
        return newBuilder(instance).build();
    }

    public static S2iBuildConfigBuilder newBuilder(S2iBuild instance) {
        return new S2iBuildConfigBuilder(new io.dekorate.s2i.config.S2iBuildConfig(null,
                    null,
                    instance.registry(),
                    instance.group(),
                    instance.name(),
                    instance.version(),
                    instance.image(),
                    instance.dockerFile(),
                    instance.autoBuildEnabled(),
                    instance.autoPushEnabled(),
                    instance.enabled(),
                    instance.builderImage(),
                    Arrays.asList(instance.buildEnvVars()).stream().map(i ->new io.dekorate.kubernetes.config.Env(i.name(),
                    i.value(),
                    i.secret(),
                    i.configmap(),
                    i.field(),
                    i.resourceField())).collect(Collectors.toList()).toArray(new io.dekorate.kubernetes.config.Env[0]),
                    instance.autoDeployEnabled()));
    }

    public static S2iBuildConfig adapt(Map map) {
        return new io.dekorate.s2i.config.S2iBuildConfig(
        null,
        null,
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("registry", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("group", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("name", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("version", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("image", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("dockerFile", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("autoBuildEnabled", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("autoPushEnabled", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("enabled", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("builderImage", null) : null),
                       Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("buildEnvVars" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("field", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("resourceField", null) : null))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("autoDeployEnabled", null) : null));
    }

    public static S2iBuildConfigBuilder newBuilder(Map map) {
        return new S2iBuildConfigBuilder(new io.dekorate.s2i.config.S2iBuildConfig(
        null,
        null,
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("registry", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("group", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("name", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("version", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("image", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("dockerFile", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("autoBuildEnabled", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("autoPushEnabled", null) : null),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("enabled", null) : null),
                       (String)(map instanceof Map ? ((Map)map).getOrDefault("builderImage", null) : null),
                       Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("buildEnvVars" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("field", null) : null),
                       (String)(i instanceof Map ? ((Map)i).getOrDefault("resourceField", null) : null))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]),
                       (Boolean)(map instanceof Map ? ((Map)map).getOrDefault("autoDeployEnabled", null) : null)));
    }

    public static String[] toStringArray(Object o) {
                if (o instanceof String[]) {
                  return (String[]) o;
                }
                if (o instanceof String) {
                  String s =  (String) o;
                  return s.split(",[ ]*");
                }
                else if (o instanceof List) {
                  List c = (List) o;
                  String[] result = new String[c.size()]; 
                  for (int i=0; i <= c.size(); i++) {
                    result[i] = String.valueOf(c.get(i));
                  }
                  return result;
                }
                return new String[0];
            
    }

}
